#
# M    graph  link
# (   router)
#
#
#
# $LIB_PL=".";
require "$LIB_PL/build_graph.pll";
1;
#
#   - 2 
# 1. 1  /       - for 
# 2. 1  /    - for 1 hour
#
# ,     .
#  1 -  yes.
#  - file, title, mode.
sub plot_link {
my($dir, $title, $mode, $date) = (@_);
my(@IN_u) = ();        # IN util
my(@IN_p) = ();        # IN packets/s
my(@IN_s) = ();        # IN pack size
my(@OUT_u) = ();       # OUT u
my(@OUT_p) = ();       # OUT p/s
my(@OUT_s) = ();       # OUT size
my(@IN_d) = ();
my(@OUT_d) = ();
my(@IN_e) = ();
my(@OUT_e) = ();
my(@CH_NN) = ();
my(@CH_STATUS) = ();
my(@CH_DOWN) = ();
my(@CH_TEST) = ();
my($MAXP_IN, $MAXP_OUT, $MAXS_IN, $MAXS_OUT,$MAXP,$MAXU_IN,$MAXU_OUT) = (10,10,1000,1000,10,0,0);
#
#  
my $S_Gx = 100;
my $S_Gy = 100;
#
if ( $mode == 1 ) {
    $S_Gx = 100;
    $S_Gy = 240;
};
if ( $mode == 2 ) {
    $S_Gx = 200;
    $S_Gy = 400;
};
#
my $BW;
my ($d,$t,$bw,$iu,$iu_m,$ip,$ip_m,$ou,$ou_m,$op,$op_m,$ie,$ie_m,$oe,$oe_m,$id,$id_m,$od,$od_m);
my ($st,$i, $nn);
#
#
my $monthly = 0;
my ($d_yy,$d_mon,$d_day) = split(/\./,$date);
if ( $d_day == 0 ) {
       $d_day = 1;
       $monthly = 1;
};
#    
my $I_0 = 0;
my $I_detail = 4; # 4 graph  
my $I_1 = 24 * $I_detail;
my @I_label = ();
$I_label[0]            =  "${F}0";
$I_label[6*$I_detail]  =  "${F}6";
$I_label[12*$I_detail] =  "${F}12";
$I_label[18*$I_detail] =  "${F}18";
my $I_name = "Hour";
my $file = "$dir/$date";
my $Nmarks = $I_detail;
if ( $monthly  ) {
    $I_detail = 0.5; # 1 graph  2 
    $I_0 = 0;
    $I_1 = int (31 * 24 * $I_detail) ;
    @I_label = ();
    for( $i = 5; $i < 31; $i += 5 ) {
	    $I_label[($i-1) * 12] = "${F}$i";
    };
    $I_name = "Day";
    $file = "cd $dir && cat $date* |";
    $Nmarks = int(24*$I_detail);
};
#
#   file
#
open(STAT,$file) || pt_fatal("No accounting file $file");
#
#  ,  ,   yes.
my ($yy, $mm, $dd, $hh, $min, $ss);
while ( <STAT> ) {
    chop;
    ($d,$t,$bw,$iu,$iu_m,$ip,$ip_m,$ou,$ou_m,$op,$op_m,$ie,$ie_m,$oe,$oe_m,$id,$id_m,$od,$od_m) = split(/[ \/,]+/);
    $d =~ /^(\d+)\.(\d+)\.(\d+)$/;
    $yy = $1; $mm = $2; $dd = $3;
    $t =~ /^(\d+)\:(\d+)\:(\d+)$/;
    $hh = $1; $min = $2; $ss = $3;
    $idx = int($hh * $I_detail + $min / (60 / $I_detail) );
    $idx += int(24 * ($dd - 1 ) * $I_detail) if $monthly;
    #
    $Max_i = $idx if $Max_i < $idx;
    if ( $bw =~ /\d+/ ) {
	$CH_STATUS[$idx] = "U" if $CH_STATUS[$idx] eq "";
	$BW = $bw;
	$IN_u[$idx] += $iu;
	$IN_p[$idx] += $ip;
	$IN_e[$idx] += $ie;
	$IN_d[$idx] += $id;
	#
	$OUT_u[$idx] += $ou;
	$OUT_p[$idx] += $op;
	$OUT_e[$idx] += $oe;
	$OUT_d[$idx] += $od;
	#
	@CH_NN[$idx]++;
    } else {
	   $st = $bw;
	   $st =~ s/^(.).*$/$1/;
	   $_ = "$CH_STATUS[$idx]$st";
	   s/UU/U/g; s/DD/D/g; s/TT/T/g;
	   $CH_STATUS[$idx] = $_;
	   $CH_STATUS[$idx+1] = $st;
    };
};
#
#   file.   - (1) , (2)  for 
# (3)     ,      status.
#
if ( $monthly == 1 && $Max_i > 20 ) {
       $I_1 = $Max_i;
};
$st = "UP"; $i0 = 0;
for ( $i = $I_0; $i <= $I_1; $i++) {
    $nn = $CH_NN[$i];
    if ( $nn > 0 ) {
	$IN_u[$i] /= $nn;
	$IN_p[$i] /= $nn;
	$IN_e[$i] /= $nn;
	$IN_d[$i] /= $nn;
	#
	$OUT_u[$i] /= $nn;
	$OUT_p[$i] /= $nn;
	$OUT_e[$i] /= $nn;
	$OUT_d[$i] /= $nn;
	$MAXU_IN =$IN_u[$i]  if $IN_u[$i]  > $MAXU_IN ;
	$MAXU_OUT=$OUT_u[$i] if $OUT_u[$i] > $MAXU_OUT;
	$MAXP_IN=$IN_p[$i] if $IN_p[$i] > $MAXP_IN;
	$MAXP_OUT=$OUT_p[$i] if $OUT_p[$i] > $MAXP_OUT;
	$IN_s[$i] = ($IN_u[$i] * $BW * 10 / 8) / $IN_p[$i] if $IN_p[$i] && ($IN_p[$i] > 1.0);
	$OUT_s[$i] = ($OUT_u[$i] * $BW * 10 / 8) / $OUT_p[$i] if $OUT_p[$i] && ($OUT_p[$i] > 1.0);
    };
#
# If    ,  status   UD
#
#  4  : U D T UD    4 .
    $_ = $CH_STATUS[$i];
    $_ =~ s/U//g;
    $_ = length($_);
    $_ = 3 if $_ > 3;
    $_ *= 5;
    $CH_STATUS[$i] = $_;
};
#
#
#
foreach $i (20,50,100,200,500,1000,2000,5000,10000,20000,50000,100000,200000,500000,1000000)
{
	$MAXP = $i;
	last if ( ($MAXP_IN < $i) && ($MAXP_OUT < $i));
};
#
#
#     graphs,   .
#
$dt = localtime(time());

print <<EOFG1;
<TABLE>
<TR><TD COLSPAN=4 ALING=CENTER BGCOLOR=WHITE>$title [$BW]</TD></TR>
<TR><TD VALIGN=TOP>
EOFG1
#
#
#   Traffic
my @gifs = ($G_Black, $G_G, $G_O, $G_R, $G_Blue);
my @Titles = ("${F}Traffic %","${F}Drops %","${F}Errors %","${F}Failures");
my @pData = (\@IN_u, \@IN_d, \@IN_e, \@CH_STATUS);
$P100 = 100;
$P100 = 50 if $MAXU_IN <= 50;
$P100 = 20 if $MAXU_IN <= 20;
$P100 = 10 if $MAXU_IN <= 10;
$P100 = 5 if $MAXU_IN <= 5;
plot_graph(\@gifs, $I_0, $I_1,"${F}Incoming traffic %",\@Titles,"${F}$I_name\n",\@I_label ,\@pData,$P100,$S_Gy,$S_Gx,0,$Nmarks,0);
#   graph
@gifs = ($G_Black, $G_G, $G_O, $G_R, $G_Blue);
@pData = (\@OUT_u, \@OUT_d, \@OUT_e, \@CH_STATUS);
print "</TD><TD VALIGN=TOP>\n";
$P100 = 100;
$P100 = 50 if $MAXU_OUT <= 50;
$P100 = 20 if $MAXU_OUT <= 20;
$P100 = 10 if $MAXU_OUT <= 10;
$P100 = 5 if $MAXU_OUT <= 5;
plot_graph(\@gifs, $I_0, $I_1,"${F}Outgoing traffic %",\@Titles,"${F}$I_name\n",\@I_label ,\@pData,$P100,$S_Gy,$S_Gx,0,$Nmarks,0);
#  graph K / K
@gifs = ($G_Black, $G_G);
@pData = (\@IN_p);
@Titles= ("Inp/sek");
print "</TD><TD VALIGN=TOP>\n";
plot_graph(\@gifs, $I_0, $I_1,"${F}Packets/second",\@Titles,"${F}$I_name",\@I_label ,\@pData,$MAXP,$S_Gy,$S_Gx,0,$Nmarks,0);
@gifs = ($G_Black, $G_G);
@pData = (\@OUT_p);
@Titles= ("Outp/sek");
print "</TD><TD VALIGN=TOP>\n";
plot_graph(\@gifs, $I_0, $I_1,"${F}Packets/second",\@Titles,"${F}$I_name",\@I_label ,\@pData,$MAXP,$S_Gy,$S_Gx,0,$Nmarks,0);
#  graphs   
@gifs = ($G_Black, $G_G);
@pData = (\@IN_s);
@Titles= ("In bytes");
print "</TD></TR><TR><TD VALIGN=TOP>\n";
plot_graph(\@gifs, $I_0, $I_1,"${F}Average packet size",\@Titles,"${F}<br>Hour",\@I_label ,\@pData,1000,$S_Gy,$S_Gx,0,$Nmarks,0);
@gifs = ($G_Black, $G_G);
@pData = (\@OUT_s);
@Titles= ("Out bytes");
print "</TD><TD VALIGN=TOP>\n";
plot_graph(\@gifs, $I_0, $I_1,"${F}Average packet size",\@Titles,"${F}<br>Hour",\@I_label ,\@pData,1000,$S_Gy,$S_Gx,0,$Nmarks,0);
print <<EOFSx;
</TD>
</TR>
</TABLE>
</BODY>
</HTML>
EOFSx
return(0);
};


