#
#   .
# $TICK_DIR -  catalogue     KM
# 1. The base K .   :
# (1) The base     file ()
# (2)   Type..M
# (3)   
#      
# ..M - 
#  -    CHG -  status,  DEL - delete 
# EXPIRE -  0,  ,     .
# who -   yes  
# Comment
# M -   . M   .
#
#  CHG ,     , 
#    yes .
#  DEL ,    delete   .
#           , 
#    .  REALLY   ticket_chk  t_check.
#
# K  ..M
# Type - R - router, I - interface.
#    ,  -  for   (   
#    ),   field:
# Type_ - TICKET
# :
#       ticket_name
#       ticket_op
#       ticket_expire
#       ticket_create
#       ticket_comment
#       ticket_arg
#
# Weight      t_check  ticket_chk
#   ,  $chg yes  ,      !
$TICK_DIR="TST" if !$TICK_DIR;
my %TICKETS;
my $TICKETS_OPEN = ""; # "r" -  , "w" -  .      file
my $TICKETS_CHG = 0;
my $TICKETS_CHG=0;
#
# 
#
my $T_FILE="$TICK_DIR/tickets.tab";
my $T_LOCK="$TICK_DIR/tickets.lck";
my $T_LOG="$TICK_DIR/log.tab";
1;
#
# t_list()     
#
sub t_list {
       return(sort keys(%TICKETS));
};
#    - t_check
# t_check (Type,Name,Stat,Reason,REALLY) = (Chg,_status, Expire,Comment)
#   yes    ,   
#    .
sub t_check {
my ($t,$n,$s,$r,$real) = @_;
return(ticket_chk("$t.$n.$s",$real));
};

#
# tickets_open(mode) mode == 'r'  'w'
#  -   , -1 - .
sub tickets_open
{
       my ( $mode ) = @_;
       my ($key, $arg, $nt);
       $mode = "r" if $mode ne "w";
       #
       # 1.  
       #    ,       - file  port.
       if ( $T_MODE ) {
	      return if $mode eq $T_MODE;
	      if ( $mode eq "r" ) {
		      close (LOCK);
		      $T_MODE = $mode;
		      return(0);
	      };
	      #
	      # If   ,     -  
	      #
       };
       $T_MODE = $mode;
       if ( $T_MODE eq "w" ) {
	   if ( ! open(LOCK,">$T_LOCK") ) {
	      print "Can't open lock file $T_LOCK: $!\n";
	      return(-1);
	   };
	   flock(LOCK,2);
       };
       #
       # 2.  file  ( ,   )
       #
       if ( ! open(TICKETS,$T_FILE) ) {
	      print "Can't open TICKET file $T_FILE: $!\n";
	      %TICKETS=();
	      $nt = 0;
	      $TICKETS_CHG=0;
	      return(0); #     ...
       };
       #
       # 3.  file ,  .
       #
       %TICKETS=();
       $nt = 0;
       $TICKETS_CHG=0;
       while ( <TICKETS> ) {
	      next if /^#/ || /^$/;
	      chop;
	      ($key,$arg) = split(/\t/,$_,2);
	      $TICKETS{$key} = $arg;
	      $nt++;
       };
       #
       # 4. If      ,  file yes  file .
       #    If     ,   file yes (for ).
       close(TICKETS);
       if ( $T_MODE eq "r" ) {
	      close(LOCK);
       };
       #
       # 5. . yes   .
       #
       return($nt);
};

#
# tickets_close
#  - 0 - no   , >0 -   , <0 - .
sub tickets_close {
       my ($key);
       if ( $T_MODE ne "w" ) {
	       $T_MODE = "";
	       return(0);
       };
       if ( $TICKETS_CHG == 0 ) {
	       close(LOCK);
	       $T_MODE = "";
	       return(0);
       };
       if ( ! open(NEW,">$T_FILE.new" ) ) {
	       print "Can not open $T_FILE.new: $!\n";
	       close(LOCK);
	       $T_MODE = "";
	       return(-1);
       };
       $key = localtime(time());
       print NEW "# $key, pid=$$ chg=$TICKETS_CHG\n";
       $! = 0;
       foreach $key (sort keys(%TICKETS) ) {
	       print NEW "$key\t$TICKETS{$key}\n";
       };
       close(NEW);
       if ( $! != 0 ) {
	       print "Can't write to $T_FILE.new: $!\n";
	       close(LOCK);
	       $T_MODE = "";
	       return(-1);
       };
       unlink("$T_FILE.old");
       link($T_FILE,"$T_FILE.old");
       if ( ! rename("$T_FILE.new",$T_FILE) ) {
	       print "Can not rename $T_FILE.new to $T_FILE: $!\n";
	       close(LOCK);
	       $T_MODE = "";
	       return(-1);
       };
       close(LOCK);
       $T_MODE = "";
       return(0);
};

############  for     ###################
#
# ticket_chk("..M",REALLY) = (CHG,STATUS,EXPIRE,COMMENT)
#  REALLY -  1,  yes  ,  yes.
#         K ,  for    ,     
#
sub ticket_chk {
       my ($key,$really) = (@_);
#
#  ,      ,    ,
#    
#
       return() if ( ! $T_MODE && tickets_open("r") < 0 );
#
       my $t = time();
       $_ = $TICKETS{$key};
       return () if ! $_ ;  # No,  no.
#
#    for field.
#
       my ( $op, $expire, $chg, $comment,@args ) = split(/\t/,$_);
       if ( $expire != 0 && $expire < $t ) {
	       ticket_del($key,"EXPIRED");
	       wrt_log($key,"EXP","") if $T_MODE eq "w";
	       return();
       };
       #
       if ( $really && $op eq "DEL" ) {
	       my $key1;
	       foreach $key1 ( @args ) {
		       ticket_del($key1,"DEL by ticket");
		       wrt_log($key,"DEL","") if $T_MODE eq "w";
	       };
	       return();
       };
       if ( $op eq "CHG" ) {
	       return($chg,$args[0],$expire,$comment);       #  status
       };
       #   -  
       return();
};

#
# ticket_get(key) -> (OP,EXPIRE,CHG,COMMENT,args)
#
sub ticket_get {
       my ($key) = (@_);
#
#  ,      ,    ,
#    
#
       return() if ( ! $T_MODE && tickets_open("r") < 0 );
#
       my $t = time();
       $_ = $TICKETS{$key};
       return () if ! $_ ;  # No,  no.
#
#    for field.
#
       my ( $op, $expire, $chg, $comment,@args ) = split(/\t/,$_);
       if ( $expire != 0 && $expire < $t ) {
	       ticket_del($key,"EXPIRED");
	       return();
       };
#
       return ( $op, $expire, $chg, $comment,@args );
};


#
# ticket_del(key,comment) - yes 
#
sub ticket_del {
       my ($key,$comm) = @_;
#
#     journal  ,   yes 
#
       delete $TICKETS{$key};
       $TICKETS_CHG++;
#
#       journal
#  ,     
       return;
};

#
#  
# ticket_add(key, OP,EXPIRE,COMMENT,ARGS)
sub ticket_add {
       my ($key, $op,$expire, $comm, @args) = @_;
       my $chg = get_chg();
       my $line;
#      1.       .
       $key =~ s/[\t\n]/ /;
       $op =~ s/[\t\n]/ /;
       $comm =~ s/[\t\n]/ /;
       $expire = int($expire);
#      2.  .
       $line = join("\t",($op,$expire,$chg,$comm,@args));
       $TICKETS{$key} = $line;
       $TICKETS_CHG++;
       return(1);
};

sub get_chg {
my (@dt) = localtime(time());
my $user = $ENV{"REMOTE_USER"};
$user = getlogin() if ( ! $user );
$user = "unknown" if ! $user;
$dt[4]++;
$dt[5] += 1900 if $dt[5] < 1900;
$user =~ s/\t//;
return ("$dt[5].$dt[4].$dt[3]/$dt[2]:$dt[1]:$dt[0] $user");
};

#
#    journal
# wrt_log(K,,K).
# Record   2 journal:
#   LOG.
# Journal yes   catalog $A_DIR,  LOG.<>. If   yes - yes 
#
sub wrt_log {
    #
    # 1.   
    #
    my ($key,$type,$txt) = @_;
    my (@dt) = localtime(time());
    my $i;
    my $user = $ENV{"REMOTE_USER"};
    $user = getlogin() if ( ! $user );
    $user = "unknown" if ! $user;
    #
    @dt[4]++;
    @dt[5]+= 1900;
    foreach $i (0,1,2,3,4,5) {
	$dt[$i] = "0$dt[$i]" if $dt[$i] < 10;
    };
    #
    my $out = "$key\t$dt[5].$dt[4].$dt[3] $dt[2]:$dt[1]:$dt[0]\t$user\t$type\t$txt\n";
    my $log_f1 = "$LOG_DIR/LOG.$dt[5].$dt[4].$dt[3]";
    my $log_f2 = "";
    $log_f2 = "$ST_DIR/$A_DIR/$LOG_STAT_NAME" if $A_DIR;
    $i = 0;
    if ( open(LOG,">>$log_f1") ) {
	   print LOG $out;
	   close(LOG);
	   $i++;
    };
    if ( open(LOG,">>$log_f2") ) {
	   print LOG $out;
	   close(LOG);
	   $i++;
    };
    return($i);
};

#
#   file.  for file  catalog statistic.  yes
#  ,    . M   
#  .
# pt_log(M,FILE,Date,Format) - yes LOG     .
sub pt_log {
my ($max,$file,$Idate,$format) = @_;
my ($key,$date,$who,$ltype,$txt);
my $ld,$lt;
my $i = 0;
my %OPS = ("DEL","  ","EXP","  ","LOG","   journal","RPL"," ","PUT","yes ","RM","yes ","ERR","   ");
my $ltext;
my $s1, $s2, $a,$a1;
my $ktype,$kname;
my $end="";
my $o_ld, $cindex=0;
my @C=("BGCOLOR=olive","BGCOLOR=silver");
# print "tail -r $file |\n";
$Idate = "" if $Idate !~ /^\d+\.\d+\.*\d*/;
if ( $file eq "" ) {
       $file = "$LOG_DIR/LOG.$Idate";
       $Idate = "";
};
open(LOG,"tail -r $file |") || return(0);
while ( <LOG> ) {
   chop;
   ($key,$date,$who,$ltype,$txt) = split(/\t/,$_);
   $ltext = $ltype;
   $ltext = $OPS{$ltype} if ( $OPS{$ltype} );
   ($ld,$lt)=split(/ /,$date);
   next if  $Idate && $Idate ne $ld;
   if ( $o_ld ne $ld ) {
       $o_ld = $ld;
       $cindex = ( $cindex+1) % 2 ;
   };
   if ( $format == 1 ) {
       $i++;
       if ( $i == 1 ) {
	   $end = "</DL>";
	   print "<DL>\n";
       };
       $txt =~ s/</&lt;/g;
       $txt =~ s/>/&gt;/g;
       if ( $ltype eq "RM" || $ltype eq "EXP" || $ltype eq "DEL" )
       {
	   print "<DT>$date <I>$who</I> $ltext  $key</DT>\n";
       } else {
	   print "<DT>$date <I>$who</I> $ltext  $key:</DT><DD><B>$txt</B></DD>\n";
       };
       if ( $max && $i > $max ) {
	   print "<DT>...</DT><DD>...</DD>\n";
	   last;
       };
   } else {
       next if $ltype eq "RM" || $ltype eq "EXP" || $ltype eq "DEL" || $ltext eq "" ;
       $txt =~ s/\((\w*)\-\>(\w*)\)//;
       $s1 = $1;
       $s2 = $2;
       $s1 = $S_COMMENTS{$s1} if $S_COMMENTS{$s1};
       $s2 = $S_COMMENTS{$s2} if $S_COMMENTS{$s2};
       $txt =~ s/</&lt;/g;
       $txt =~ s/>/&gt;/g;
#
       ($ktype,$kname) = split(/\./,$key);
       $ktype =~ s/^P://;
       $a = $a1 = "";
       $a = "<A href=\"$ASK?op=LONG&SEARCH=$ktype.$kname\">" if $ktype && $kname;
       $a1 = "</A>" if $a;
       $ktype = $O_NAME{$ktype} if $O_NAME{$ktype};
#
       $i++;
       if ( $i == 1 ) {
       print <<EOTL1;
<TABLE BORDER=2>
<TR>
<TH>Type</TH>
<TH>Object</TH>
<TH>Record</TH>
<TH>Was</TH>
<TH>Became</TH>
<TH>Who</TH>
<TH>Where</TH>
</TR>
EOTL1
       $end=<<EOTL3;
</TABLE>
EOTL3
       };
       print <<EOTL2;
<TR>
<TD>$F$ktype</TD>
<TD>$a$kname$a1</TD>
<TD>$txt</TD>
<TD>$F$s1</TD>
<TD>$F$s2</TD>
<TD $C[$cindex]>$F$who</TD>
<TD $C[$cindex]>$F$date</TD>
</TR>
EOTL2
    };
};
close(LOG);
print "$end";
return $i;
};

#
#     (type.name.status)  3  -
#    ,       K
# ($n,$t,$w) = t_split($s)
sub t_split {
($_) = @_;
my ($t,$n,$w);
$_ =~ /^([^.]*)\.(.*)\.([^.]*)$/;
$t = $1;
$n = $2;
$w = $3;
return($t,$n,$w);
};
