#!/usr/bin/perl
#   
#        
#   $ST_DIR/MODEMS_   :
# /
#   
# *      
# *      
# *   
#   '*'      /E1,     
#  ,    ,   $ST_DIR/MODEMS___
#      -    ,
#   '/' -       
#     -f CONFIG  ( ) $MODEMS_CONF
#     Modems.conf.
#
use strict;
#   :
$main::LIB_PL="/usr/local/libexec/stat";
require "$main::LIB_PL/build_lib.pll";
# ,   HTML ,  
my $HTML_FILE;
my %CONFIG_ROUTERS;
my %POOL = ();
my ($RSH) = "rsh -Knt20";
my $Target_LINK="TARGET=\"$main::Window_LINK\"";
my $TIMER=30;
#
while ( $_ = shift @ARGV ) {
       if ( $_ eq '-h' ) {
	       $HTML_FILE = shift @ARGV;
	       next;
       };
       if ( $_ eq '-c' ) {
	       $main::MODEMS_CONF = shift @ARGV;
	       next;
       };
       if ( $_ eq '-d' ) {
	       $main::DEBUG = 1;
	       next;
       };
       print <<Usage;
Usage: $0 [-d] [-c CONFIG] [-h HTML_FILE]
Usage
       exit 1;
};
#
Read_Config($main::MODEMS_CONF);
#
#
#
#
my $router;
my ($s,$n, $p, $pc, $ps);    #  ,    ,    
my %STAT = %POOL;        # Initialise accounting
foreach $router (keys %CONFIG_ROUTERS) {
       $pc = $CONFIG_ROUTERS{$router};
       $RSH = $pc->{_RSH};
       #
       # 1.       
       #
       my (%LINES) = ();
       my ($userinfo,$status,$nbusy, $navail, $nsuccess, $nfail,$summ) = ();
       #
       #  ,   'who'
       #
       my @ANS;
       #- $SIG{ALARM} = 'killer';
       #- alarm($TIMER);
       @ANS = `$RSH $router who 2>/dev/null`;
       #- alarm(0);
       $status = 0;;
       if ( $? == 0 ) {
	      $status = 1;
	      foreach $_ (@ANS) {
		      chop;
		      s/^\*?\s*//;
		      my ($lnum,$lname,$lindex,$userinfo);
		      if ( $pc->{_UNIX} ) {
			       ($userinfo,$lname) = split(/\s+/,$_);
			       ## print STDERR "UNIX: $lname $userinfo\n";
		      } else {
			       ($lnum,$lname,$lindex,$userinfo) = split(/\s+/,$_,4);
				if ( $lnum == "tty" ) {
					$userinfo = $lindex;
					$lindex = $lname;
					$lname = $lnum;
					$lindex = substr($lindex, 2);
					$lnum = $lindex;
				};
			       $userinfo =~ s/\d\d:\d\d:\d\d.*$//;
			       $lname = "$lname$lindex";
			       ## print STDERR "CISCO: $lname $userinfo\n";
		      };
		      $LINES{$lname} = $userinfo;
	      };
       };
       #
       #    E1,     'show modem sum'.
       #
       $summ = 0;
       if ( $status && $pc->{_E1} ) {
       # alarm($TIMER);
       @ANS = `$RSH $router show modem sum 2>/dev/null`;
       # alarm(0);
	       if ( $? == 0 ) {
		      $_ = $ANS[3];
		      chop;
		      s/^\s+//;
		      @_ = split(/\s+/,$_);
		      $navail = $_[3];
		      $nsuccess = $_[2];
		      $nfail = $_[1];
		      $summ = 1;
	       };
       };
       #
       #             
       #
       foreach $s (keys %STAT) {
	      next if ( ! $pc->{"_POOL_$s"} ); # No this pool on this router
	      $p = $STAT{$s};
	      $p->{nPOLL} += $pc->{"_POOL_$s"} if $status;
	      if ( $status ) {
		 $p->{STATUS} = "U" if ( ! $p->{STATUS} );
		 $p->{STATUS} = "P" if $p->{STATUS} eq "D";
	      } else {
		 $p->{STATUS} = "D" if ( ! $p->{STATUS} );
		 $p->{STATUS} = "P" if $p->{STATUS} eq "U";
	      };
	      #
	      #    
	      #    E1
	      if ( $summ ) {
		     $p->{SUMM} += 1;
		     $p->{nAVAIL} += $navail;
		     $p->{nSUCCESS} += $nsuccess;
		     $p->{nFAIL} += $nfail;
	      };
	      if ( $p->{nUSED} eq "" ) {
		       $p->{nUSED} = $p->{nUSER} = 0;
	      };
	      foreach $n (keys %LINES) {
		     next if $pc->{$n} ne $s;
		     if ( ($_ = $LINES{$n}) ) {
			     $p->{nUSED} += 1;
			     $p->{nUSER} += 1 if $LINES{$n} !~ /^idle/;
			     $_ =~ s/^(.........).*/$1/;
			     push @{$p->{USERS}},$_;
		     };
	      };
	      #
	      #    
	      #
       };
       #
       #    
       #
};
#
#       
#
#      (  ) 2  
my($sec,$min,$hour,$day,$mon,$year) = localtime(time());
$mon += 1;
my $yy = $year;
$year += 1900;
#
my $file = sprintf("%04d.%02d.%02d",$year,$mon,$day);
my $dt = sprintf("%02d.%02d.%02d %02d:%02d:%02d",$yy,$mon,$day,$hour,$min,$sec);
my $dir;
foreach $s (keys %STAT) {
       $p = $STAT{$s};
       $dir = "$main::ST_DIR/MODEMS_$s";
       mkdir "$dir",0775 if ! -d "$dir";
	if ( ! open(OUT,">>$dir/$file") ) {
		print STDERR "$! - $dir/$file\n";
		next;
	};
       print OUT               "#date time status polled used users [avail_modems success_calls failed_calls]\n" if -z "$dir/$file";
       ! $main::DEBUG || print STDERR "$dir/$file: #date time status polled used users [avail_modems success_calls failed_calls]\n" if -z "$dir/$file";
       print OUT                "$dt $p->{STATUS} $p->{nPOLL} $p->{nUSED} $p->{nUSER}";
       ! $main::DEBUG || print STDERR "$dir/$file: $dt $p->{STATUS} $p->{nPOLL} $p->{nUSED} $p->{nUSER}";
       if ( $p->{nSUCCESS} ) {
	       print OUT    " $p->{nAVAIL} $p->{nSUCCESS} $p->{nFAIL}\n";
	       ! $main::DEBUG || print STDERR " $p->{nAVAIL} $p->{nSUCCESS} $p->{nFAIL}\n";
       } else {
		print OUT   "\n";
	       ! $main::DEBUG || print STDERR "\n";
       };
	close OUT;
};
#
#        
#
if ( $HTML_FILE ) {
       exit 1 if ! open(HTML,">$HTML_FILE.new");
       print HTML <<EOF1;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//RU" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML lang="ru">
<HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=koi8-r">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Refresh" CONTENT=60>
<TITLE>MODEM POOLS STATUS</TITLE>
</HEAD>
<BODY>
<CENTER>$dt</CENTER>
<TABLE BORDER=2>
<TR>
 <TH></TH><TH></TH><TH></TH><TH></TH><TH></TH>
<TH></TH><TH></TH>
</TR>
EOF1
my ($warn) = 0;
my @colors = ("GREEN","OLIVE","RED");
my $C;   #  
my $C0;  #  
my $C1;  #   
my $C2;  #   
my $C3;  #    
my $free;
my ($S_POLL, $S_USER, $S_FREE);
foreach $s (sort keys %STAT) {
       ($C,$C0,$C1,$C2,$C3) = ();
       $p = $STAT{$s};
       $free = $p->{nPOLL} - $p->{nUSED};
       $S_FREE += $free;
       $S_POLL += $p->{nPOLL};
       $S_USER += $p->{nUSER};
       $warn = 0;
       if ( $p->{STATUS} eq "P" ) {
	 $warn = 1 if $warn < 1;
	 $C0 = "<FONT COLOR=\"$colors[1]\">";
       };
       if ( $p->{STATUS} eq "D" ) {
	 $warn = 2 if $warn < 2;
	 $C0 = "<FONT COLOR=\"$colors[2]\">";
       };
       if ( $free < 3 ) {
	 $warn = 1 if $warn < 1;
	 $C1 = "<FONT COLOR=\"$colors[2]\">";
       };
       if ( $p->{nUSER} < 1) {
	 $warn = 1 if $warn < 1;
	 $C3 = "<FONT COLOR=\"$colors[2]\">";
       };
       if ( $p->{nAVAIL} ne "" && $p->{nAVAIL} < 3 ) {
	 $warn = 1 if $warn < 1;
	 $C2 = "<FONT COLOR=\"$colors[2]\">";
       };
       @_ = @{$p->{USERS}};
       grep {
       s/^.*@.*$/<FONT COLOR="RED">$&/;
       s/^[0-9]/<FONT COLOR="GREEN">$&/;
       s/^pp/<FONT COLOR="BLUE">$&/;
       s/^uu/<FONT COLOR="OLIVE">$&/;
       s/^ip/<FONT COLOR="MAGENTA">$&/;
       s/^<FONT.*$/$&<\/FONT>/; } @_;
       $_ = join(" ",@_);
       print HTML<<EOF2;
<TR>
 <TD>$main::F<B><A $Target_LINK href="$main::ASKI?op=GETM&name=$s&dir=MODEMS_$s">$s</A></B></FONT></TD>
 <TD BGCOLOR="$colors[$warn]">$C0$p->{STATUS}</TD>
 <TD>$p->{nPOLL}</TD>
 <TD>$C3$p->{nUSER}</TD>
 <TD>$C1$free</TD>
 <TD>$C2$p->{nAVAIL}</TD>
 <TD><FONT SIZE=-2><B>$_</B></FONT></TD>
</TR>
EOF2
};
$_ = join(':',sort keys %STAT);
print HTML<<EOF3;
<TR>
<TD><A $Target_LINK HREF="$main::ASKI?op=GETM.all&name=$_">${main::F}<B>:</A></B></FONT></TD>
<TD></TD>
<TD>$S_POLL</TD>
<TD>$S_USER</TD>
<TD>$S_FREE</TD>
</TR>
</TABLE>
</BODY>
</HTML>
EOF3
close HTML;
rename ("$HTML_FILE.new",$HTML_FILE);
! $main::DEBUG || print STDERR "html OK: $HTML_FILE\n";
};
exit 0;

sub Read_Config {
       my ($file) = @_;
       open(CONF,$file) || die("Can't open conf file $file: $!");
       config:
       while(<CONF>) {
	      my ($name,$conf);
	      chop;
	      next if /^\s*#/; # 
	      next if /^\s*$/;  #  
	      #
	      # 
	      #
	      if ( /^(\w+)=(.*)$/ ) {
		       $name=$1;
		       $conf=$2;
		       if ( $name eq "RSH" ) {
			       $RSH = $conf;
			       next;
		       };
		       if ( $name eq "STAT" ) {
			       $main::ST_DIR = $conf;
			       next;
		       };
		       if ( $name eq "TIMER" ) {
			       $TIMER = $conf;
			       next;
		       };
		       print STDERR "Unknown: $name = $conf\n";
		       next;
	      };
	      ($name,$conf) = split(/\s+/,$_,2);
	      my ($pc,$c1, $c2, $nlines, $i, $s, $t) = ();
	      $CONFIG_ROUTERS{$name} = {} if ! $CONFIG_ROUTERS{$name};
	      $pc = $CONFIG_ROUTERS{$name};
	      $pc->{_RSH} = $RSH;
	      foreach $c1 (split /\;/,$conf)  {
		     #
		     # First, get POOL_NAME ($s)
		     ($c2,$s) = split(/:/,$c1,2);
		     if ( ! $s ) {
		       print STDERR "Bad config line: $c1, no :SPOOL_NAME\n";
		       next;
		     };
		     $ps = $POOL{$s};
		     $ps = $POOL{$s} = {} if ! $ps;
		     $ps->{USERS} = [];
		     # Then, get all options
		     my ($list,@opts) = split(/\//,$c2);
		     # Now analyse the options
		     foreach $i (@opts) {
		       if ( $i =~ /^\d+$/ ) {
			 $pc->{_NLINES} += $i;   # Lines, per seria
			 $ps->{_NLINES} += $i;   # Lines, per router
			 $pc->{"_POOL_$s"} = $i;  # Lines, this seria on this router
			 next;
		       };
		       # Then, get /UNIX
		       if ( $i eq "UNIX" ) {
			 $pc->{_UNIX} = 1;
			 next;
		       };
		       # Then, get /E1
		       if ( $i eq "E1" ) {
			 $pc->{_E1} = 1;
			 $ps->{_POOL} = $s; # For the accounting
			 next;
		       };
		       # There is an error if there exist another / options
		       print STDERR "Unknown option $i\n";
		     };
		     # Now analyze the range or the list of the lines
		     # If it's the RANGE, get it
		     if ( $list =~ /^([A-Za-z_]*)(\d+)-\1(\d+)$/ ) {
		       $c1 = $2; $c2 = $3;
		       $t = $1; $t = "tty" if ! $t;
		       $c2 = $c1 if ! ($c2 > $c1);
		       for ($i = $c1; $i <= $c2; $i++) {
			       $pc->{"$t$i"} = $s;
		       };
		       if ( ! $pc->{"_POOL_$s"} ) {
			       $pc->{_NLINES} += ($c2 - $c1 + 1);
			       $ps->{_NLINES} += ($c2 - $c1 + 1);
			       $pc->{"_POOL_$s"} = ($c2 - $c1 + 1);
		       };
		     # Else it's the list
		     } else {
		       $c1 = 0;
		       foreach $i (split /,/,$list) {
			       $pc->{$i} = $s;
			       $c1++;
		       };
		       if ( ! $pc->{"_POOL_$s"} ) {
			       $pc->{_NLINES} += $c1;
			       $ps->{_NLINES} += $c1;
			       $pc->{"_POOL_$s"} = $c1;
		       };
		     };
	      };
	      my $k;
	      if ( $main::DEBUG ) {
	       foreach $k (keys %{$pc}) {
		       print STDERR "config{$name}{$k} = $pc->{$k}\n";
	       };
	      };
       };
       close CONF;
       return;
};

sub killer {
my ($sig) = @_;
print STDERR "SIGNAL $sig\n";
return(0);
};
