#include "regexp.h"

/*
 * Replace the matching substring with the subsitution
 * string and write the modified source string to dst.
 */
void regreplace(r, subst, dst)
	const regexp *r;
	const char *subst;
	register char *dst;
{
	register int len;
	register const char *src;

	if( r == 0 || r->magic != REGEXP_MAGIC || r->matchstr == 0 ) {
		regerror("no regular expression");
		return;
	}

	/* Copy the prefix */
	src = r->matchstr;
	len = r->startp[0] - src;
	if( len < 0 ) {
	fouled: regerror("match string damaged");
		return;
	} else if( len > 0 ) {
		memcpy(dst, src, len);
		src += len;
		dst += len;
	}

	/* Skip the matched substring */
	len = r->endp[0] - r->startp[0];
	if( len < 0 )
		goto fouled;
	src += len;

	/* Do actual substitution */
	len = regnsub(r, subst, strlen(subst), dst);
	if( len == -1 )
		return;
	dst += len;

	/* Finally, copy the suffix (including the trailing \0) */
	len = (r->matchstrlen + r->matchstr) - src + 1;
	if( len < 1 )
		goto fouled;
	memcpy(dst, src, len);
}
