#include "regexp.h"

/*
 * Substitute the matching substring
 */
void regsub(r, src, dst)
	const regexp *r;
	register const char *src;
	register char *dst;
{
	register char c;
	register int len;

	if( r == 0 || r->magic != REGEXP_MAGIC ) {
		regerror("no regular expression");
		return;
	}
	while( c = *src++ ) {
		if( c == '\\' ) {
			c = *src++;
			if( '0' <= c && c <= '9' ) 
				c -= '0';
			else {
				if( c != '&' && c != '\\' ) {
					*dst++ = '\\';
					if( c == 0 )
						break;
				}
				*dst++ = c;
				continue;
			}
		} else if( c != '&' ) {
			*dst++ = c;
			continue;
		} else
			c = 0;
		if( r->startp[c] == 0 )
			continue;
		len = r->endp[c] - r->startp[c];
		if( len == 0 )
			continue;
		if( len < 0 ) {
			regerror("damaged match string");
			return;
		}
		memcpy(dst, r->startp[c], len);
		dst += len;
	}
	*dst = 0;
}
