#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>

/* #define RE_DEBUG 1 */
#define STD_REGEXP

#define regexp my_regexp
#define regcomp my_regcomp
#define regexec my_regexec
#define regerror my_regerror
#define regsub my_regsub
#define regprint my_regprint

#include "regexp.c"

#undef regexp
#undef regcomp
#undef regexec
#undef regerror
#undef regsub
#undef regprint

#include <regexp.h>

main(ac, av)
	char **av;
{
	char buf[2048];
	char buf1[2048];
	char buf2[2048];
	my_regexp *r;
#ifdef STD_REGEXP
	regexp *hsr;
#endif
	char *p, *index();
	int i, n;
	struct rusage r1, r2;
	int nloops = 0;

	if( ac > 1 )
		nloops = atoi(av[1]);

	for(;;) {
		printf("RE? ");
		fflush(stdout);
		if( fgets(buf, sizeof buf, stdin) == NULL )
			break;
		if( p = index(buf, '\n') )
			*p = 0;
#ifdef STD_REGEXP
		hsr = regcomp(buf);
		r = my_regcomp(buf);
		if( r == 0 || hsr == 0 ) {
			if( r != 0 )
				free(r);
			if( hsr != 0 )
				free(hsr);
			continue;
		}
#else
		r = my_regcomp(buf);
		if( r == 0 )
			continue;
#endif
		for(;;) {
#ifdef RE_DEBUG
			my_regprint(r);
#endif
			printf("STR? ");
			fflush(stdout);
			if( fgets(buf, sizeof buf, stdin) == NULL )
				break;
			if( p = index(buf, '\n') )
				*p = 0;
			if( !strcmp(buf, ".") )
				break;
#ifdef STD_REGEXP
			if( regexec(hsr, buf) ) {
				printf("HS : %s\n", buf);
				for( i = 0; i < NSUBEXP; i++ ) {
					if( hsr->startp[i] == 0 )
						continue;
					printf("%2d---%*s", i,
						hsr->startp[i] - buf, "");
					n = hsr->endp[i] - hsr->startp[i];
					if( n )
						printf("%.*s\n", n, "===================================================================================");
					else
						printf("^\n");
				}
			} else
				printf("HS: NO MATCH\n");
#endif
			if( my_regexec(r, buf) ) {
				printf("MY : %s\n", buf);
				for( i = 0; i < NSUBEXP; i++ ) {
					if( r->startp[i] == 0 )
						continue;
					printf("%2d---%*s", i,
						r->startp[i] - buf, "");
					n = r->endp[i] - r->startp[i];
					if( n )
						printf("%.*s\n", n, "===================================================================================");
					else
						printf("^\n");
				}
			} else
				printf("MY: NO MATCH\n");
			
			printf("SUBST? ");
			fflush(stdout);
			if( fgets(buf1, sizeof buf1, stdin) == NULL )
				break;
			if( p = index(buf1, '\n') )
				*p = 0;
			regsub(r, buf1, buf2);
			printf("SUB: >%s<\n", buf2);
			printf("SUBLEN: %d\n", regnsub(r, buf1, strlen(buf1), 0));
			regreplace(r, buf1, buf2);
			printf("REPL: >%s<\n", buf2);
			printf("REPLEN: %d\n", regnreplace(r, buf1, strlen(buf1), 0));
			if( nloops == 0 )
				continue;
#ifdef STD_REGEXP
			getrusage(0, &r1);
			for( i = nloops ; i > 0 ; i-- )
				(void) regexec(hsr, buf);
			getrusage(0, &r2);
			i = 1000000*(r2.ru_utime.tv_sec - r1.ru_utime.tv_sec);
			i += r2.ru_utime.tv_usec - r1.ru_utime.tv_usec;
			printf("HS ate %d.%03d secs\n", i/1000000,
							(i/1000) % 1000);
#endif
			getrusage(0, &r1);
			for( i = nloops ; i > 0 ; i-- )
				(void) my_regexec(r, buf);
			getrusage(0, &r2);
			i = 1000000*(r2.ru_utime.tv_sec - r1.ru_utime.tv_sec);
			i += r2.ru_utime.tv_usec - r1.ru_utime.tv_usec;
			printf("MY ate %d.%03d secs\n", i/1000000,
							(i/1000) % 1000);
		}
#ifdef STD_REGEXP
		free(hsr);
#endif
		free(r);
	}
	exit(0);
}

void regerror(err)
	const char *err;
{
	printf("HS ERR: %s\n", err);
}

void my_regerror(err)
	const char *err;
{
	printf("MY ERR: %s\n", err);
}
