/*
 * Bandwidth conversion utility
 *
 * Usage: cvtbw new-bw [src-file] > dst-file
 */

#include <stdio.h>
#include "manifest.h"

char base_dir[1], *av0;

main(ac, av)
	int ac;
	char **av;
{
	double atof();
/*adbr                
        float new_bw, old_bw, r;
*/                              
        double old_bw;
        float new_bw, r;

	struct tm *tm;
	struct LAGG la;
	u_long tt;
	int i;
	FILE *f;

	av0 = av[0];
	if( ac < 2 || ac > 3 ) {
		fprintf(stderr, "Usage: %s new-bw [src-file]", av0);
		exit(1);
	}
	if( ac == 2 )
		f = stdin;
	else if( (f = fopen(av[2], "r")) == NULL ) {
		fprintf(stderr, "%s: cannot open %s\n", av0, av[2]);
		exit(1);
	}
	new_bw = atof(av[1]);

	while( (i = rdlog(f, &tt, &la, &old_bw, 0l, (u_long)-1l)) > 0 ) {
		tm = localtime(&tt);
		printf("%02d.%02d.%02d %02d:%02d:%02d ",
			tm->tm_year % 100, tm->tm_mon + 1, tm->tm_mday,
			tm->tm_hour, tm->tm_min, tm->tm_sec);
		switch( i ) {
		case IF_UP:       printf("UP\n"); break;
		case IF_DOWN:     printf("DOWN\n"); break;
		case IF_TESTING:  printf("TESTING\n"); break;
		case IF_STAT:
			r = old_bw / new_bw;
			la.s_inutil *= r;
			la.s_inpeakutil *= r;
			la.s_oututil *= r;
			la.s_outpeakutil *= r;
			if( la.s_inpeakutil > 100.0 )
				la.s_inpeakutil = 100.0;
			if( la.s_inutil > la.s_inpeakutil )
				la.s_inutil = la.s_inpeakutil;
			if( la.s_outpeakutil > 100.0 )
				la.s_outpeakutil = 100.0;
			if( la.s_oututil > la.s_outpeakutil )
				la.s_oututil = la.s_outpeakutil;

			printf("%.1f %.1f/%.1f %.1f/%.1f, %.1f/%.1f %.1f/%.1f, %.2f %.2f\n",
			       new_bw,
			       la.s_inutil, la.s_inpeakutil,
			       la.s_inpckts, la.s_inpeakpckts,
			       la.s_oututil, la.s_outpeakutil,
			       la.s_outpckts, la.s_outpeakpckts,
			       la.s_inerrors, la.s_outdrops);
		}
	}
	exit(0);
}
