#include "manifest.h"

/*
 * Parse date
 */

static mon_days[] = {
	31, 28, 31, 30,
	31, 30, 31, 31,
	30, 31, 30, 31
};

int mondays(mo, yr)
int mo, yr;
{
	int dpm;

	if( mo < 1 || mo > 12 )
		return (0);
	dpm = mon_days[mo-1];    /* days per month */
	if( mo == 2 && !(yr % 4) && ((yr % 100) || !(yr % 400)) )
		dpm++;          /* february in leap years */
	return (dpm);
}

int parsedate (date, yrp, mop, dyp, pp)
char *date;
int *yrp, *mop, *dyp;  /* starting year/month/day */
enum FILE_CHANGE *pp;
{
	int yr, mo, dy;     /* starting year/month/day */
	int dpm;            /* days per month */
	struct tm tm;
	u_long  tt;
	char    *cp;
	enum FILE_CHANGE period = *pp;

	if( !strcmp(date, "today") ) {
		tt = time(0);
		tm = *localtime(&tt);
		yr = tm.tm_year + 1900;
		mo = tm.tm_mon + 1;
		dy = tm.tm_mday;
		period = DAILY;
	} else if( !strcmp(date, "yesterday") ) {
		tt = time(0) - (24*60*60);
		tm = *localtime(&tt);
		yr = tm.tm_year + 1900;
		mo = tm.tm_mon + 1;
		dy = tm.tm_mday;
		period = DAILY;
	} else if( !strcmp(date, "lastweek") ) {
		tt = time(0) - (24*60*60*7);
		tm = *localtime(&tt);
		yr = tm.tm_year + 1900;
		mo = tm.tm_mon + 1;
		dy = tm.tm_mday;
		period = WEEKLY;
	} else {
		cp = index(date, '.');
		if( cp == 0 )
		    goto bdf;
		*cp = 0;
		yr = xatoi(date);
		if( yr < 0 )
			goto bdf;
		if( yr < 100 )
			yr += (yr < 80) ? 2000 : 1900;
		date = cp + 1;
		cp = index(date, '.');
		if( cp )
			*cp = 0;
		mo = xatoi(date);
		dpm = mondays (mo, yr);
		if (!dpm)
			goto bdf;
		dy = 1;
		if( cp ) {
			dy = xatoi(cp+1);
			if( dy < 1 || dy > dpm )
				goto bdf;
			if( period == NONE )
				period = DAILY;
		} else if( period == NONE )
			period = MONTHLY;
	}
	*yrp = yr;
	*mop = mo;
	*dyp = dy;
	*pp = period;
	return (0);
bdf:
	return (1);
}

/*
 * My version of atoi -- returns -1 on errors
 */
int
xatoi(s)
	char *s;
{
	int n = 0;

	while( *s ) {
		if( *s < '0' || *s > '9' )
			return -1;
		n = n*10 + (*s++ - '0');
	}
	return n;
}

