/*
 *
 * Author: Aleksei Roudnev
 * snmplinkrep
 *    .
 * /.   :/
 * :
 *   ,    ,
 */
#ifndef lint
static char rcsid[] = "$Id: snmplinkrep.c,v 1.2 1999/08/17 17:45:55 alex Exp $";
#endif

#include "manifest.h"
#include <string.h>

/*
 * Report data for accounting system and for WWW board
 * snmptab


 */
#include <ctype.h>
#include <math.h>
char *calloc();

#ifndef REGEXPINCL
#define INIT    register char *bp = instring;
#define GETC()  (*bp++)
#define PEEKC() (*bp)
#define UNGETC(c) bp--
#define RETURN(c) return (c);
#define ERROR(c) regerr(c)
#include <regexp.h>
#else
#include REGEXPINCL
#endif

char *av0;

char expbuf[1024];


char *numeral();

int parsedate();

char *arg_pp, *arg_ap;

FILE *open_linklog();

char *tod(), *saytime();

extern u_long down_at;
struct L_STAT {
       u_long l_s_time;  /* start time */
       u_long l_e_time;  /* end time   */
       u_long l_t_down;  /* time down  */
       int    l_n_down;  /* time down  */
       int    l_n_agg;   /* number of records */
       struct LAGG l_LAGG;
};
static char *mon_names[] = {
	"", "", "", "",
	"", "", "", "",
	"", "", "", ""
};
/*
 *   
 */
# define TS "<TABLE BORDER=1>"
# define FNT "<FONT SIZE=-2>"
# define MAX_LINES 30

main(ac, av)
	int ac;
	char **av;
{
	extern char *optarg;
	extern int optind;
	register char c;
	char *cf = CONFIG_FILE;
	char *of = NULL;       /* Out file for accounting */
	char *date;
	int yr, mo, dy; /* starting year/month/day */
	int cyr, cmo, cdy, hr;
	int i, j, ndays, nmatch, ntroubled;
	int nline = 0, npage = 0;
#ifndef REGEXPINCL
	char *res[128]; /* Regular expressions */
#else
	regexp *res[128];
#endif
	char *re, *index(), *p;
	int nres, rn;
	char buf[512];

	enum FILE_CHANGE period = NONE;
	enum FILE_CHANGE rdfc();
	/* For EXACT name search */
	char *link_name = (char*)0;
	char *int_name  = (char*)0;
	char *rtr_name  = (char*)0;

	struct GATEWAY *g;
	struct IF *ii;
	FILE *f, *stf = NULL;

	struct LAGG la;
	struct GAGG ga;
	struct L_STAT *pL_STAT = 0;
	register struct L_STAT *plstat;

	char   *i_pname;
	int hr_start = 0, hr_end = 24;
	struct tm tm;
	u_long tot,tt, start_tt, end_tt;
	double t_a_speed  = 0.0;
	double t_in_rate  = 0.0;
	double t_out_rate = 0.0;
	int    t_n_links = 0;
	int    n_stat_recs = 0;

	char *m_ln;
	struct GATEWAY *ok_g, *m_g;
	double speed;

	int ever_up;    /* link/router was ever up */
	long last_fail;  /* last failure ended at */
	long l_up_sum, l_down_sum;
	int l_mean_ctr;
	long r_up_sum, r_down_sum;
	int r_mean_ctr;
	int perdays =0, perhours = 0; /*       */
	int nrecs=1;                  /*      */
	int quiet = 0;
	char *stat_file = (char *)0;
	av0 = av[0];
	hr_end = 24;
	for(;;) {
	       /*
		* :
		* -c CONFIG_FILE
		* -t PERIOD (MONTHS/WEEK/DAY/HOUR)
		* -o out_file - file for DATA BASE
		* -h hour:hour
		* -q -  _   _
		* -s  -    
		*/
	       switch( getopt(ac, av, "qc:h:t:o:s:") ) {
		case -1:
			if( optind < ac )
				break;
		default:
		usage:
			fprintf(stderr, "Usage: %s [-q] [-s STAT_FILE] [-h] [-c config_file] [-t period] [-o out_file] year.month[.day] [name...]\n", av0);
			exit(1);

		case 'q':
		       quiet = 1;
		       continue;
		case 's':
		       stat_file = optarg;
		       if ( stat_file[0] == '-' )
			       stf = stdout;
		       else if ( ! ( stf = fopen(stat_file,"w") ))  {
			       fprintf(stderr,"Can't create stat file:");
			       perror(stat_file);
			       exit(1);
		       };
		       continue;
		case 'h':
			p = optarg;
			hr_start = iget(&p);
			if( *p++ != '-' || hr_start < 0 || hr_start > 23 )
				goto usage;
			hr_end = iget(&p);
			if( hr_end == 0 )
				hr_end = 24;
			if( *p != 0 || hr_end <= hr_start )
				goto usage;
			continue;

		case 'c':
			cf = optarg;
			continue;


		case 't':
			period = rdfc(optarg);
			if( period < DAILY || period > MONTHLY ) {
				fprintf(stderr, "%s: bad period, valid periods are: day, week, month\n", av0);
				exit(1);
			}
			continue;

		case 'o':
			of = optarg;
			continue;
		}
		break;
	}

	/*
	 * Parse date
	 */
	date = av[optind++];
	if (parsedate (date, &yr, &mo, &dy, &period)) {
		fprintf(stdout, "%s: bad date format (should be like 93.2 or 2001.11.03)\n", av0);
		exit(1);
	}
	/*
	 * Compile regular expressions
	 */
#ifndef REGEXPINCL
	re = expbuf;
	nres = 0;
	for( i = optind ; i < ac ; i++ ) {
		/* R=name - THIS router - unused while */
		if ( av[i][0] == 'R' && av[i][1] == '=' ) {
		       rtr_name = & (av[i][2]);
		       break;
		};
		/* L=name - THIS link */
		if ( av[i][0] == 'L' && av[i][1] == '=' ) {
		       link_name = & (av[i][2]);
		       break;
		};
		/* I=name:name - THIS interface */
		if ( av[i][0] == 'I' && av[i][1] == '=' ) {
		       int_name = & (av[i][2]);
		       break;
		};
		if( nres >= sizeof res / sizeof res[0] ) {
			fprintf(stderr, "%s: too many regular expressions\n", av[0]);
			exit(1);
		}
		res[nres++] = re;
		for( p = av[i] ; *p ; p++ ) {
			if( isupper(*p) )
				*p = tolower(*p);
		}
		re = compile(av[i], re, &expbuf[sizeof expbuf - 1], 0);
	}
#else
	nres = 0;
	for( i = optind ; i < ac ; i++ ) {
		/* R=name - THIS router - unused while */
		if ( av[i][0] == 'R' && av[i][1] == '=' ) {
		       rtr_name = & (av[i][2]);
		       break;
		};
		/* L=name - THIS link */
		if ( av[i][0] == 'L' && av[i][1] == '=' ) {
		       link_name = & (av[i][2]);
		       break;
		};
		/* I=name:name - THIS interface */
		if ( av[i][0] == 'I' && av[i][1] == '=' ) {
		       int_name = & (av[i][2]);
		       break;
		};
		for( p = av[i] ; *p ; p++ ) {
			if( isupper(*p) )
				*p = tolower(*p);
		}
		if( (res[nres++] = regcomp(av[i])) == 0 )
			exit(1);
	}
#endif /*REGEXPINCL*/


	/*
	 * Read in the configuration file
	 */
	if( rdconfig(cf) )
		exit(1);

	/*
	 *   
	 *
	 *  -   MONTHLY  WEEKLY    
	 *              DAILY    .
	 */
	switch( period ) {
		case MONTHLY:
			hr_start = 0;
			hr_end = 24;
			nrecs = ndays = mondays (mo, yr);
			perdays=1;
			perhours=0;
			break;
		case WEEKLY:
			hr_start = 0;
			hr_end = 24;
			nrecs = ndays = 7;
			perdays=1;
			perhours=0;
			break;
		case DAILY:
			perdays=0;
			perhours=1;
			ndays = 1;
			nrecs=24;
			break;
	}




	/*    */
	nmatch = 0;
	ntroubled = 0;
	tt = time(0);
	/*
	 *   .
	 *  ,  
	 */
	for( rn = (nres?0:-1) ; rn < nres ; rn++ ) {
		for( g = gwlist ; g ; g = g->g_next ) {
			for( ii = g->g_ifs ; ii < &g->g_ifs[g->g_nifs] ; ii++ ) {
				if ( int_name ) {
				    /* Compare for router.name:interface  */
				    strcpy(buf, g->g_sname);
				    strcat(buf, ":");
				    strcat(buf, ii->i_name);
				    if( !strcasecmp(int_name, buf) )
					    goto matched;

				    /* Compare for router-addr:interface */
				    strcpy(buf, g->g_sname);
				    strcat(buf, ":");
				    strcat(buf, ii->i_name);
				    if( !strcasecmp(int_name, buf) )
					goto matched;
				    continue;
				};
				if ( link_name ) {
				       char *p;
				       strcpy(buf,ii->i_comment);
				       if ( p = strchr(buf,' ') )  *p  = 0;
				       if ( !strcasecmp(link_name,buf) )
					       goto matched;
				       continue;
				};
				if( nres == 0 )
					goto matched;

				/* Compare for full.router.name:interface  */
				strcpy(buf, g->g_name);
				strcat(buf, ":");
				strcat(buf, ii->i_name);
				if( !strcasecmp(av[rn+optind], buf) )
					goto matched;

				/* Compare for short-router-name:interface */
				strcpy(buf, g->g_sname);
				strcat(buf, ":");
				strcat(buf, ii->i_name);
				if( !strcasecmp(av[rn+optind], buf) )
					goto matched;
				/* Try to mactch file and comment fields */
				re = buf;
				for( p = ii->i_comment ; *p ; p++ )
					*re++ = isupper(*p) ? tolower(*p) : *p;
				*re = 0;
#ifndef REGEXPINCL
				if( step(buf, res[rn]) )
					goto matched;
#else
				if( regexec(res[rn], buf) )
					goto matched;
#endif
				re = buf;
				for( p = ii->i_logdir ; *p ; p++ )
					*re++ = isupper(*p) ? tolower(*p) : *p;
				*re = 0;
#ifndef REGEXPINCL
				if( step(buf, res[rn]) )
					goto matched;
#else
				if( regexec(res[rn], buf) )
					goto matched;
#endif
				continue;

			matched:
				if( ii->i_index++ )
					continue;       /* already processed! */

				/* Open the link log file */
				cyr = yr; cmo = mo; cdy = dy;
				f = open_linklog(ii->i_logdir, yr, mo, dy);
				if( f == 0 ) {
					       fprintf(stderr, "%s: (warning) -- no log file %s/%d.%02d.%02d\n",
							av0, ii->i_logdir, yr, mo, dy);
					continue;
				}

				/* Read the records */
				nmatch++;
				/*
				 *   -    //
				 */
				speed = 0.0;
				if ( pL_STAT )
				{
					free(pL_STAT);
					pL_STAT = 0;
				};
				/* One more record (last one) - average valuew */
				pL_STAT = (struct L_STAT *)calloc(nrecs+1, sizeof(struct L_STAT) );
				if ( !pL_STAT ) {
				       perror("Can't allocate memory for L_STAT");
				       exit(1);
				};
				/*      */
				tt = time(0);
				tm = *localtime(&tt);
				tm.tm_year = yr - 1900;
				tm.tm_mday = dy;
				tm.tm_mon = mo - 1;
				tm.tm_hour = 0;
				tm.tm_min = 0;
				tm.tm_sec = 0;
				start_tt = timelocal(&tm);
				start_tt += hr_start * 60 * 60;
				end_tt = start_tt + ndays * 24 * 60 * 60;
				end_tt -= (24 - hr_end) * 60 * 60;
				tot = end_tt - start_tt;
				/*        */
				for ( i = 0; i <= nrecs; i++) {
				       tt = timelocal(&tm);

				       if ( i < nrecs) pL_STAT[i].l_s_time = tt;
				       if ( i > 0 ) pL_STAT[i-1].l_e_time = tt;
				       if ( perdays )   tm.tm_mday++;
						   else tm.tm_hour++;
				};
				/* Last record - SUMMARIES */
				pL_STAT[nrecs].l_s_time = start_tt;
				pL_STAT[nrecs].l_e_time = end_tt;
				last_fail = (u_long) -1;
				ever_up = 0;
			cont2:  while( (i = rdlog(f, &tt, &la, &speed, start_tt, end_tt)) > 0 ) {
					long t;
					/* Process records */
					switch( i ) {
					case IF_UP:
						ever_up = 1;
						if( down_at == (u_long)-1 )
							continue;
						t = tt - down_at;
						if( t > 1 ) {
							set_down(pL_STAT,nrecs,down_at,tt);
						}
						down_at = (u_long)-1;
						break;

					case IF_DOWN:
					case IF_TESTING:
						if( down_at != (u_long)-1 )
							continue;
						down_at = tt;
						break;

					case IF_STAT:
# define A_ADD(f) plstat->l_LAGG.f = (plstat->l_LAGG.f * plstat->l_n_agg + la.f) / ( plstat->l_n_agg + 1)
# define M_ADD(f) plstat->l_LAGG.f = (la.f > plstat->l_LAGG.f ? la.f : plstat->l_LAGG.f);
						for(j = 0; j < nrecs+1; j++) {
						       plstat = & pL_STAT[j];
						       if ( ! (tt >= plstat->l_s_time && tt < plstat->l_e_time) )
							       continue;
							   A_ADD(s_inutil);
							   M_ADD(s_inpeakutil);
							   A_ADD(s_inpckts);
							   M_ADD(s_inpeakpckts);
							   A_ADD(s_oututil);
							   M_ADD(s_outpeakutil);
							   A_ADD(s_outpckts);
							   M_ADD(s_outpeakpckts);
							   A_ADD(s_inerrors);
							   M_ADD(s_inpeakerrors);
							   A_ADD(s_outerrors);
							   M_ADD(s_outpeakerrors);
							   A_ADD(s_indrops);
							   M_ADD(s_inpeakdrops);
							   A_ADD(s_outdrops);
							   M_ADD(s_outpeakdrops);
							   plstat->l_n_agg++;
						};
					}
				}
				if( i == -2 )
					goto end_reached1;

				/* Try to open the next log file */
				switch( file_change ) {
				case DAILY:
					if( period == DAILY )
						break;
				nextday:
					if( ++cdy > mondays (cmo, cyr) ) {
						cdy -= mondays (cmo, cyr);
						if( ++cmo > 12 ) {
							cmo = 1;
							cyr++;
						}
					}

					/* Do we need to open a new file? */
					tm.tm_year = cyr - 1900;
					tm.tm_mday = cdy;
					tm.tm_mon = cmo - 1;
					tm.tm_hour = 0;
					tm.tm_min = 0;
					tm.tm_sec = 0;
					if( timelocal(&tm) >= end_tt )
						break;

					/* Try to open the new log file */
					fclose(f);
					f = open_linklog(ii->i_logdir, cyr, cmo, cdy);
					if( f != 0 )
						goto cont2;
					break;

				case WEEKLY:
					cdy += 6;
					goto nextday;

				case MONTHLY:
					if( period == DAILY || period == MONTHLY )
						break;
					cdy += 100;
					goto nextday;
				}

			end_reached1:
				if( down_at != (u_long)-1 ) {
					set_down( pL_STAT,nrecs, down_at,end_tt);
				} else {
					if( last_fail == (u_long)-1 )
						l_up_sum += end_tt - start_tt;
					else
						l_up_sum += end_tt - last_fail;
				}
				i_pname = ii->i_comment[0] ? ii->i_comment : ii->i_name;
				if ( (p = index(i_pname,' ')) ) *p = 0;
				/*      */
				t_a_speed  += speed;
				if ( pL_STAT[nrecs].l_n_agg > 0 && ( pL_STAT[nrecs].l_LAGG.s_inutil >0.0 || pL_STAT[nrecs].l_LAGG.s_oututil > 0.0 ) ) {
				       t_in_rate  += speed * pL_STAT[nrecs].l_LAGG.s_inutil / 100.0;
				       t_out_rate += speed * pL_STAT[nrecs].l_LAGG.s_oututil  / 100.0;
				};
				t_n_links++;

				if ( stf ) {
				       for ( i = 0; i < nrecs; i++ )
				       {
					      u_long t_p;
					      u_long d_t;
					      struct tm *ttm;
					      char tbuf[32];
					      char *source;
					      plstat = pL_STAT + i;
					      t_p = (plstat->l_e_time - plstat->l_s_time);
					      /*
					       * 1.    ,   
					       * 1998-03-12/22:01
					       *
					       */
					      ttm = localtime(&(plstat->l_s_time));
					      sprintf(tbuf,"%04d-%02d-%02d/%02d:%02d",ttm->tm_year+1900, ttm->tm_mon+1,ttm->tm_mday, ttm->tm_hour, (ttm->tm_min?ttm->tm_min:1));
					      source = g->g_sname;
					      if ( ! source ) source = g->g_name;
					      /*
					       * 1.        
					       */
					      if ( plstat->l_n_down || plstat->l_t_down )
					      {
						       n_stat_recs++;
						       fprintf(stf, "%s LNK_down %d %ld %s %s channel\n",i_pname,plstat->l_n_down,plstat->l_t_down,tbuf,source);
					      };
					      if ( plstat->l_n_agg ) {
						       n_stat_recs++;
						       fprintf(stf,"%s LNK_spd_inu %d %d %s %s channel\n",i_pname,(int)(speed*1000),(int)(speed * 10 * plstat->l_LAGG.s_inutil ),tbuf,source);
						       n_stat_recs++;
						       fprintf(stf,"%s LNK_spd_outu %d %d %s %s channel\n" ,i_pname,(int)(speed*1000),(int)(speed * 10 * plstat->l_LAGG.s_oututil ) ,tbuf,source);
						       if ( plstat->l_LAGG.s_outdrops > 1.0 || plstat->l_LAGG.s_inerrors > 1.0 )
						       {
							       n_stat_recs++;
							       fprintf(stf,"%s LNK_od_ie %d %d %s %s channel\n",i_pname,(int)(plstat->l_LAGG.s_outdrops),(int)(plstat->l_LAGG.s_inerrors),tbuf,source);
						       };
					      };
				       };
				};
				if ( ! quiet ) {
				       if ( nline % MAX_LINES == 0 ) {
					   if ( nline > 0 )
					      printf("</TABLE>\n<HR>\n");
					   npage++;
					   printf("<P ALIGN=RIGHT>page %d</P>\n%s\n<TR>\n\t<TH COLSPAN=%d>Link statistic for ",npage,TS,(nrecs+4));
					   time_header (tt, start_tt, end_tt, yr, mo, dy, hr_start, hr_end, period);
					   printf("</TH>\n</TR>\n");
					   printf("<TR><TH>%sLink</TH><TH>%sKbit</TH><TH>%s%s:</TH>",FNT,FNT,FNT,(ndays > 1?"":""));
					   if ( perhours ) {
						      for ( i = 0; i < nrecs; i++ )
							     printf("<TH>%s%d</TH>",FNT,i+1);
					   } else {
						      for ( i = 0; i < nrecs; i++ ) {
							     j = dy + i;
							     if( j > mondays (cmo, cyr) )
							     j -= mondays (cmo, cyr);
							     printf("<TH>%s%d</TH>",FNT,j);
						      }
					   }
					   printf("<TH>%sSumm:</TH>",FNT,i+1);
					   printf("</TR>\n");
				       };
				       nline++;
				       printf ("<TR>\n \t<TD ROWSPAN=5>%s%s</TD>\n \t<TD ROWSPAN=5>%s%8.1f</TD>\n",
					       FNT,i_pname,FNT,speed);
				       printf("\t<TD BGCOLOR=WHITE NOWRAP>%sdown, min:</TD>\n",FNT);
				       for ( i = 0; i < nrecs+1; i++ )
				       {
					      u_long t_p;
					      u_long d_t;
					      plstat = pL_STAT + i;
					      t_p = (plstat->l_e_time - plstat->l_s_time);
					      if ( plstat->l_t_down == 0 && plstat->l_n_agg == 0 )
						      printf(" \t<TD BGCOLOR=BLACK>%s-</TD>\n",FNT);
					      else
					      {
						      d_t = plstat->l_t_down;
						      printf(" \t<TD BGCOLOR=%s>%s%3.1f</TD>\n", (d_t > 0 ? (d_t > t_p/3? "RED":"YELLOW"):"GREEN"),FNT,d_t/60.0);
					      };
				       };
				       printf("\n</TR>\n<TR>\n\t<TD>%sin:</TD>\n",FNT);
				       for ( i = 0; i < nrecs+1; i++ )
				       {
					      plstat = pL_STAT + i;
					      printf(" \t<TD>%s%3.1f%%</TD>\n",FNT,plstat->l_LAGG.s_inutil);
				       };
				       printf("\n</TR>\n<TR>\n\t<TD> max:</TD>\n",FNT);
				       for ( i = 0; i < nrecs+1; i++ )
				       {
					      plstat = pL_STAT + i;
					      printf(" \t<TD>%s%3.1f%%</TD>\n",FNT,plstat->l_LAGG.s_inpeakutil);
				       };
				       printf("\n</TR>\n<TR>\n\t<TD>%sout:</TD>\n",FNT);
				       for ( i = 0; i < nrecs+1; i++ )
				       {
					      plstat = pL_STAT + i;
					      printf(" \t<TD>%s%3.1f%%</TD>\n",FNT,plstat->l_LAGG.s_oututil);
				       };
				       printf("\n</TR>\n<TR>\n\t<TD> max:</TD>\n",FNT);
				       for ( i = 0; i < nrecs+1; i++ )
				       {
					      plstat = pL_STAT + i;
					      printf(" \t<TD>%s%3.1f%%</TD>\n",FNT,plstat->l_LAGG.s_outpeakutil);
				       };
				       printf("\n</TR>");
				};
				if( f != 0 )
					fclose(f);
			}
		}
	}
	if ( nline > 0 )
	   printf("</TABLE>\n");
	if ( t_n_links > 1 || quiet ) {
	       printf ("<HR >\n");  /*  ,      */
	       time_header (tt, start_tt, end_tt, yr, mo, dy, hr_start, hr_end, period);
	       printf (" <TABLE BORDER=2>\n");
	       printf (" <TR><TD> :</TD><TD>%d</TD></TR>\n",t_n_links);
	       printf (" <TR><TD>  , :</TD><TD>%8.3fMbit</TD></TR>\n",t_a_speed / 1000.0 );
	       printf (" <TR><TD>    , :</TD><TD>%8.3fMbit</TD></TR>\n",t_out_rate / 1000.0 );
	       printf (" <TR><TD>    , :</TD><TD>%8.3fMbit</TD></TR>\n",t_in_rate / 1000.0 );
	       printf (" <TR><TD>   :</TD><TD>%d</TD></TR>\n",n_stat_recs );
	       printf (" </TABLE>\n");
	       printf (" </HR >\n"); /*  ,      */
       };
       if( nmatch == 0 ) {
	       fprintf(stderr, "%s: no matching link/router names (or no data)\n", av0);
	       exit(1);
       }
       exit(0);
}

set_down (pL_STAT,nrecs, start,end)
struct L_STAT *pL_STAT;
u_long start,end;
int nrecs;
{
       register int j,k,t;

       for(j = 0; j < nrecs+1; pL_STAT++, j++) {
	      t = end - start;
	      if (start >= pL_STAT->l_e_time || end < pL_STAT->l_s_time )
		      continue;
	      if ( start < pL_STAT->l_s_time)
		      t -= (pL_STAT->l_s_time - start);
	      if ( end > pL_STAT->l_e_time)
		      t -= (end - pL_STAT->l_e_time);
	      if ( t > 0 )
	      {
		      pL_STAT->l_t_down += t;
		      pL_STAT->l_n_down++;
	      };
       };
}


#ifndef REGEXPINCL
/*
 * Report an error in reg expr
 */
regerr(errno)
	int errno;
{
	char *p;

	switch( errno ) {
	default:
		fprintf(stderr, "%s: error %d in regular expression\n", av0, errno);
		exit(1);

	case 11: p = "Range endpoint too large."; break;
	case 16: p = "Bad number."; break;
	case 25: p = "``\\ digit'' out of range."; break;
	case 36: p = "Illegal or missing delimiter."; break;
	case 41: p = "No remembered search string."; break;
	case 42: p = "\\( \\) imbalance."; break;
	case 43: p = "Too many \\(."; break;
	case 44: p = "More than 2 numbers given in \\{ \\}."; break;
	case 45: p = "} expected after \\."; break;
	case 46: p = "First number exceeds second in \\{ \\}."; break;
	case 49: p = "[] imbalance."; break;
	case 50: p = "Regular expression(s) too long.";
	}
	fprintf(stderr, "%s: error in regular expression: %s\n", av0, p);
	exit(1);
}
#endif /*REGEXPINCL*/

/*
 * Produce numeral suffix
 */
char *
numeral(n)
	int n;
{
	n %= 100;
	if( (n / 10) == 1 )
		return "th";
	n %= 10;
	if( n == 1 )
		return "st";
	if( n == 2 )
		return "nd";
	if( n == 3 )
		return "rd";
	return "th";
}

/*
 * Output the time period
 */
outtime(s)
	int s;
{
	struct tp {
		int udiv;
		int umax;
		char *uname;
	} *t;
	static struct tp tpp[] = {
		60,     300,    "sec",
		60,     300,    "min",
		24,     96,     "hour",
		1000000, 0,     "day",
	};

	for( t = tpp ; ; t++ ) {
		if( s < t->udiv || (s < t->umax && (s % t->udiv) != 0) ) {
			 printf("%d %s%s", s, t->uname, s > 1 ? "s" : "");
			 break;
		}
		s /= t->udiv;
	}
}

/*
 * Print the human-readable period of time.
 */
char *
saytime(t)
	u_long t;
{
	static char buf[128];
	char *bp = buf;
	int n;

#define M      60
#define H      (60*M)
#define D      (24*H)

	if( t >= D ) {
		n = t / D;
		t %= D;
		sprintf(bp, "%d day%s", n, n > 1 ? "s" : "");
		bp += strlen(buf);
		if( t > 2*H )
			t -= t % H;     /* get rid of minutes & seconds */
		else
			t -= t % M;     /* get rid of seconds */
	}
	if( t >= H ) {
		if( bp != buf )
			*bp++ = ' ';
		n = t / H;
		t %= H;
		sprintf(bp, "%d hour%s", n, n > 1 ? "s" : "");
		bp += strlen(buf);
		if( n > 3 )
			t -= t % M;     /* get rid of seconds */
	}
	if( t >= M ) {
		if( bp != buf )
			*bp++ = ' ';
		n = t / M;
		t %= M;
		sprintf(bp, "%d min%s", n, n > 1 ? "s" : "");
		bp += strlen(buf);
	}
	if( t ) {
		if( bp != buf )
			*bp++ = ' ';
		sprintf(bp, "%d sec%s", t, t > 1 ? "s" : "");
	}
	return buf;
}

/*
 * Time of the day
 */
char *
tod(t)
	u_long t;
{
	struct tm *tm = localtime(&t);
	static char buf[128];

	sprintf(buf, "%d/%d/%d %02d:%02d:%02d",
		tm->tm_mon + 1, tm->tm_mday, tm->tm_year % 100,
		tm->tm_hour, tm->tm_min, tm->tm_sec);
	return buf;
}

time_header (tt, start_tt, end_tt, yr, mo, dy, hr_start, hr_end, period)
u_long start_tt, end_tt, tt;
int yr, mo, dy, hr_start, hr_end;
enum FILE_CHANGE period;
{
	int i;
	struct tm tms,tme;

	tms = *localtime(&start_tt);
	end_tt--;
	tme = *localtime(&end_tt);
		printf("%-02d.%-02d.%-04d/%-02d:%-02d - %-02d.%-02d.%-04d/%-02d:%-02d",tms.tm_mday,tms.tm_mon+1,tms.tm_year+1900,tms.tm_hour,tms.tm_min,tme.tm_mday,tme.tm_mon+1,tme.tm_year+1900,tme.tm_hour,tme.tm_min);
}

